import { asyncDelay, onHomeworkFinish } from "../script/util";
import { MyCocosSceneComponent } from "../script/MyCocosSceneComponent";
import Game, { GAME_STATE } from "./tool/Game";
import pg from "./tool/pg";

const { ccclass, property } = cc._decorator;

@ccclass
export default class SceneComponent extends MyCocosSceneComponent {

    addPreloadImage() {
        // TODO 根据自己的配置预加载图片资源
        this._imageResList.push({ url: this.data.pic_url });
        this._imageResList.push({ url: this.data.pic_url_2 });
    }

    addPreloadAudio() {
        // TODO 根据自己的配置预加载音频资源
        this._audioResList.push({ url: this.data.audio_url });
    }

    addPreloadAnima() {

    }

    onLoadEnd() {
        // TODO 加载完成后的逻辑写在这里, 下面的代码仅供参考
        this.initData();
        this.initView();
        this.initEvent();
        this.log("statr!!!!!!!!!!!!!")
        this.scheduleOnce(() => { pg.event.emit("game_start") }, 0.5);
    }
    protected onDestroy(): void {
        pg.event.clear();
    }

    _cantouch = null;
    initData() {
        Game.getIns().init(this.data);
        Game.getIns().reset();
        // 所有全局变量 默认都是null 
        this._cantouch = true;
    }
    private audioId: any;
    async initView() { }
    initEvent() {
        pg.event.on("game_start", () => {
            this.gameStart();
        })
        pg.event.on("game_time_over", () => {
            // alert("game_time_over")
            //这里的事件会发送的很早。但是我们需要等待动画执行完了之后再开始后续的内容
            Game.getIns().addPage();
            if (!Game.getIns().isOver) {
                return;
            }
            this.showGameOver();
        })
    }

    gameStart() {
        pg.audio.playLocalAudio(cc.find(`Canvas/res/audio/btn`));
        if (this.audioId > -1) {
            cc.audioEngine.stopAllEffects();
            // pg.audio.stopAudio(this.audioId);
        }

        Game.getIns().state = GAME_STATE.RUNNING;
        //游戏开始小鱼出现等等
        if (this.audioId > -1 && Game.getIns().state != GAME_STATE.WAIT) {
            cc.audioEngine.stopAllEffects();
            // pg.audio.stopAudio(this.audioId);
        }
    }
    private showGameOver() {
        let gameover = cc.find("gameover", this.node);
        gameover.scale = 3;
        gameover.active = true;
        this.playLocalAudio("gameover");
        cc.tween(gameover).to(0.3, { scale: 1 })
            .delay(2)
            .call(() => {
                gameover.active = false;
                //发送给上端最后的数据
                // alert("game_finish")
                let player = { right: Game.getIns().player.score, error: Game.getIns().player.error }
                onHomeworkFinish(player)
                this.log("player: " + JSON.stringify(player));
            }).start();
    }

    playLocalAudio(audioName) {
        const audio = cc.find(`Canvas/res/audio/${audioName}`).getComponent(cc.AudioSource);
        return new Promise((resolve, reject) => {
            const id = cc.audioEngine.playEffect(audio.clip, false);
            cc.audioEngine.setFinishCallback(id, () => { resolve(id); });
        })
    }
}


